#include "biblioteca.h"


// Agora vamos fazer o negocio da coisa ai
FIGURA *criarFigura(int p, int t) {		
	FIGURA *f = (FIGURA *) malloc(sizeof(FIGURA));
	
	f->np = p;	
	f->nt = t;
	f->pontos = (PONTO *) malloc( p * sizeof(PONTO) );
	f->vertices = (VERTICE *) malloc( p * sizeof(VERTICE) );
	f->triangulos = (TRIANGULO *) malloc( t * sizeof(TRIANGULO) );	

 	return f;
}

void destruirFigura(FIGURA *fig) {
	free(fig->pontos);
	free(fig->vertices);
	free(fig->triangulos);
	free(fig);
}






// Metodo que faz as transfomacoes da camera ajeitando os seus vetores (n,v,u) e que passa as
//coordenadas dos pontos do sitema canonico(mundias) para o de vista
void transformar_coordenadas(FIGURA *f, CAMERA *cam, CENA *cena, char ajeitarLuz) {
	int i;
	
#ifdef DEBUG_CAM1
	char *string = "hx %lf,hy %lf, d %lf  c = %lf,%lf,%lf";
	char *string2 = "n = %lf,%lf,%lf , v = %lf,%lf,%lf ";
	textprintf_ex(screen,font,10,10,makecol(255,0,0),-1,string, cam->hx,cam->hy,cam->d,
	              cam->foco.x,cam->foco.y ,  cam->foco.z );
	textprintf_ex(screen,font,10,20,makecol(255,0,0),-1,string2,cam->mira.x,cam->mira.y,
				  cam->mira.z,cam->vertical.x,cam->vertical.y,cam->vertical.z);	         
#endif 
	
		
		
	
	cam->vertical =  subtracao ( cam->vertical , projecao(cam->vertical,cam->mira) );
	cam->horizontal = produtoVetorial( cam->mira , cam->vertical );
	
	normalizar( &(cam->mira) );
	normalizar( &(cam->vertical) );
	normalizar( &(cam->horizontal) );
	
	// Matriz de mudanca de base
	MATRIZ m = getMatriz( cam->horizontal , cam->vertical , cam->mira );	
	
		
#ifdef DEBUG_CAM1
    char *string3 = "v = %lf,%lf,%lf  n = %lf,%lf,%lf  u = %lf,%lf,%lf";
	textprintf_ex(screen,font,10,40,makecol(255,0,0),-1,string3,cam->vertical.x,cam->vertical.y,
	              cam->vertical.z,cam->mira.x,cam->mira.y,cam->mira.z,cam->horizontal.x,
				  cam->horizontal.y,cam->horizontal.z);
	system("pause");
#endif	
	
	
	
	
	if(ajeitarLuz) cena->fonte_luz = Multiplicacao( m , criar_vetor(cam->foco,cena->fonte_luz) );
	
	
	for(i = 0; i < f->np; i++) {
		f->vertices[i].tr = (int *) malloc(f->vertices[i].nt * sizeof(int));    
		
		//Ponto colocado na coordenada de vista
		f->vertices[i].ponto = Multiplicacao( m , criar_vetor(cam->foco,f->pontos[i]) );
		 	
#ifdef DEBUG_COORD1		
	 	char *string4 = "P%d    (nt = %d)    %lf,%lf,%lf      -->      %lf , %lf , %lf";
        textprintf_ex(screen,font,10,50+(25*i),makecol(255,0,0),-1,string4,i+1,f->vertices[i].nt,
		              f->pontos[i].x,f->pontos[i].y,f->pontos[i].z,f->vertices[i].ponto.x,
					  f->vertices[i].ponto.y,f->vertices[i].ponto.z);
#endif
    }

#ifdef DEBUG_COORD1
	system("pause");
#endif

	
}



char lerConfig(CAMERA *cam, OBJETO *obj, CENA*cena) {
	double tmpx,tmpy,tmpz;
	if( freopen("config.txt","r",stdin) == NULL ) return 0;
    
	// Parametros da camera
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	cam->foco.x =  tmpx;
	cam->foco.y =  tmpy;
	cam->foco.z =  tmpz;
	
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	cam->mira.x =  tmpx;
	cam->mira.y =  tmpy;
	cam->mira.z =  tmpz;
		
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	cam->vertical.x =  tmpx;
	cam->vertical.y =  tmpy;
	cam->vertical.z =  tmpz;
	
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	cam->d =  tmpx;
	cam->hx =  tmpy;
	cam->hy =  tmpz;
	
	
	// Parametros do objeto
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	obj->cor.x =  tmpx;
	obj->cor.y =  tmpy;
	obj->cor.z =  tmpz;
		
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	obj->kd.x =  tmpx;
	obj->kd.y =  tmpy;
	obj->kd.z =  tmpz;
	
	if( scanf("%lf %lf",&tmpx,&tmpy)!= 2 ) return 0;
	obj->n  =  tmpx;
	obj->ks =  tmpy;
	
	if(obj->kd.x < 0  || obj->kd.x > 1  || obj->kd.y < 0  || obj->kd.y > 1  || obj->kd.z < 0  || 
	   obj->kd.z > 1  || obj->cor.x < 0 || obj->cor.x > 1 || obj->cor.y < 0 || obj->cor.y > 1 ||
	   obj->cor.z < 0 || obj->cor.z > 1 ||  obj->ks < 0   ||  obj->ks > 1   || obj->n < 0) {
		return 0;		
	}
	
	// parametros da cena
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	cena->fonte_luz.x =  tmpx;
	cena->fonte_luz.y =  tmpy;
	cena->fonte_luz.z =  tmpz;
	
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	cena->cor_luz.x =  tmpx;
	cena->cor_luz.y =  tmpy;
	cena->cor_luz.z =  tmpz;
	
	if( scanf("%lf %lf %lf",&tmpx,&tmpy,&tmpz)!= 3 ) return 0;
	cena->cor_ambiente.x =  tmpx;
	cena->cor_ambiente.y =  tmpy;
	cena->cor_ambiente.z =  tmpz;
	
	if( scanf("%lf",&tmpx)!= 1 ) return 0;
	cena->ka =  tmpx;

	if(cena->cor_ambiente.x < 0   || cena->cor_ambiente.x > 255 || cena->cor_ambiente.y < 0   ||
	   cena->cor_ambiente.x > 255 || cena->cor_ambiente.z < 0   || cena->cor_ambiente.z > 255 ||
	   cena->cor_luz.x < 0   || cena->cor_luz.x > 255 || cena->cor_luz.y < 0 || 
	   cena->cor_luz.y > 255 || cena->cor_luz.z < 0   || cena->cor_luz.z > 255) {
		return 0;		
	}	
	
	fclose(stdin);
	return 1;
}




FIGURA *lerArquivo(char *nomeArquivo) { // <-- inclui como parametro o nome do arquivo
    int i,p,t,v1,v2,v3;
    int diminuir;
	FIGURA *fig;
    
	if( freopen(nomeArquivo,"r",stdin) == NULL ) return NULL;
    if( scanf("%d",&diminuir)!= 1 ) return NULL;
	if( scanf("%d %d",&p,&t)!= 2 )  return NULL;
	
	fig = criarFigura(p,t);
#ifdef DEBUG_READING1
	textprintf_ex(screen,font,10,20,makecol(255,0,0),-1,"np = %d   ,   nt = %d", fig->np, fig->nt);
#endif   	
	
		
	
	// L os pontos	
	for(i = 0; i < p; i++) {
		
		fig->vertices[i].nt = 0;
        fig->vertices[i].proximo = 0;
		if(scanf("%lf %lf %lf",&(fig->pontos[i].x),&(fig->pontos[i].y),&(fig->pontos[i].z)) != 3) 
		   	return NULL;
		   	
#ifdef DEBUG_READING1
		textprintf_ex(screen,font,10,40+(i*10),makecol(255,0,0),-1,"P%d  (%lf,%lf,%lf)",
		              i+1,fig->pontos[i].x,fig->pontos[i].y,fig->pontos[i].z);
#endif   	
	}
		
#ifdef DEBUG_READING1
	system("pause");
#endif	 
	
		
	
	
    // L os triangulos 	
	for(i = 0; i < t; i++) {
		if( scanf("%d %d %d",&v1,&v2,&v3) != 3 ) return NULL;
		if(diminuir) {
			v1--;v2--;v3--;
		}
#ifdef DEBUG_READING2
		textprintf_ex(screen,font,50,500+(i*10),makecol(255,0,0),-1,"T%d  (%d,%d,%d)",i+1,v1,v2,v3);
#endif  
		
        fig->vertices[v1].nt += 1;
        fig->vertices[v2].nt += 1;
        fig->vertices[v3].nt += 1;
		fig->triangulos[i].v1 = v1;
	    fig->triangulos[i].v2 = v2;
	    fig->triangulos[i].v3 = v3;				  	  
    } 
#ifdef DEBUG_READING2
	system("pause");
#endif	 
	
	
	fclose(stdin);	
	return fig;	   
}







// Normaliza os triangulos e os vertices da figura
void normalizar_e_colorir_vertices(FIGURA *fig, CAMERA *cam, OBJETO * obj, CENA *cena) {
	COR ambiental,difusa,especular;
	VETOR normal,luz,visual,reflexao;
	VERTICE *v1,*v2,*v3;
	
	VETOR zero = { 0.0 , 0.0 , 0.0 };
	TRIANGULO *t = fig->triangulos;
	VERTICE *v = fig->vertices;
			
	int i,j,tmp;
	int nt = fig->nt;
	int np = fig->np;
	double piNL,piRV,piNV;
	
	char flagAmbiental = 1;
	char flagDifusa = 1;
	char flagEspecular = 1; 
	
	
	
	// Aqui normaliza os triangulos	
	for (i = 0; i < nt;i++) {
	    v1 = &( v[ (t[i].v1) ] );
		v2 = &( v[ (t[i].v2) ] );		
		v3 = &( v[ (t[i].v3) ] );
			
		t[i].normal = produtoVetorial( criar_vetor(v1->ponto,v2->ponto), criar_vetor(v1->ponto,v3->ponto) );		
		normalizar( &(t[i].normal) );
				
		v1->tr[ v1->proximo ] = i;
		v2->tr[ v2->proximo ] = i;
		v3->tr[ v3->proximo ] = i;
		v1->proximo += 1;
		v2->proximo += 1;
		v3->proximo += 1;						
	}	
	
	
		
		
	// Aqui normaliza os vertices
	for (i = 0; i < np; i++) {
		
		normal = zero;
		for (j = 0; j < v[i].nt; j++) {
			normal = soma( normal , t[ (v[i].tr[j]) ].normal );
		}
		if(v[i].nt > 0)  normal = divisao( normal , v[i].nt );
		
		normalizar( &(normal) );
		v[i].proximo = 0;	
		
		
#ifdef DEBUG_NORMAL
		textprintf_ex(screen,font,400,60+(i*25),makecol(255,0,0),-1,"P%d  ( %lf , %lf , %lf )",
		              i+1,normal.x,normal.y,normal.z);		
#endif
			
						
			
			
		/////////////////////////////////////////////////////////////////////////////////////////////////	
		// Define a cor do vertice	
		visual = multiplicacao(v[i].ponto,-1);
		normalizar(&visual);
		
		piNV = produtoInterno(normal,visual);
		if (piNV < 0) normal = multiplicacao(normal,-1);
			
			
		//fator ambiental
		ambiental = multiplicacao( cena->cor_ambiente , cena->ka ); 
		ajeitar_cor(&ambiental);
		
				
		
		luz = criar_vetor(v[i].ponto,cena->fonte_luz);
		normalizar(&luz);
		piNL = produtoInterno(normal,luz);		
		
		//fator de difusao
		if (piNL >= 0) {
			difusa = multiplica_cor( obj->kd , cena->cor_luz ); 
			difusa = multiplica_cor( difusa, obj->cor );
			difusa = multiplicacao( difusa , piNL );
			ajeitar_cor(&difusa); 
		} else {
			difusa = zero;
		}
			
			
			
		reflexao = subtracao( multiplicacao(normal,2*piNL) , luz );
		normalizar(&reflexao);
		piRV = produtoInterno(reflexao,visual);
		
		// fator especular 		
		if(piNL >= 0 && piRV >= 0) {
			especular = multiplicacao( cena->cor_luz , (pow(piRV,obj->n) * obj->ks) );
			ajeitar_cor(&especular);				
		} else {
			especular = zero;	
		}
		
		
		v[i].cor = zero;
		if(flagAmbiental)  v[i].cor = soma_cor(v[i].cor , ambiental);
		if(flagDifusa)     v[i].cor = soma_cor(v[i].cor , difusa);
		if(flagEspecular)  v[i].cor = soma_cor(v[i].cor , especular);
		
		printf("P%d   N %lf,%lf,%lf   V %lf,%lf,%lf  L %lf,%lf,%lf   R %lf,%lf,%lf     piNV %lf   piNL %lf   piRV %lf   COR %lf,%lf%,%lf\n",
		        i,normal.x,normal.y,normal.z,visual.x,visual.y,visual.z,luz.x,luz.y,luz.z,reflexao.x,reflexao.y,reflexao.z,piNV,piNL,piRV,v[i].cor.x,v[i].cor.y,v[i].cor.z);  
	
		
#ifdef DEBUG_COR	
	    textprintf_ex(screen,font,10,50+(22*i),makecol(255,0,0),-1,"P%d   %lf , %lf , %lf ",i+1,
		              v[i].cor.x,v[i].cor.y,v[i].cor.z);
#endif





		/////////////////////////////////////////////////////////////////////////////////////////////
		// os ponto sao colocados em perspectiva 
		
		//if (v[i].ponto->z == 0) v[i].ponto->z = 0.00000001;
		v[i].ponto.x = (cam->d * v[i].ponto.x) / (cam->hx * v[i].ponto.z);				
		v[i].ponto.y = (cam->d * v[i].ponto.y) / (cam->hy * v[i].ponto.z);
		
		//v[i].ponto.x = v[i].ponto.x / cam->hx;				
		//v[i].ponto.y = v[i].ponto.y / cam->hy;		 	
	 	
	 	v[i].ponto.x = ((v[i].ponto.x + 1) * (RES_X - 1)) / 2;
	 	v[i].ponto.y = ((1 - v[i].ponto.y) * (RES_Y - 1)) / 2;	   
		
#ifdef DEBUG_COORD2		
	    char *string3 = "P%d    %lf , %lf , %lf       ->      %lf , %lf , %lf ";
        textprintf_ex(screen,font,10,50+(22*i),makecol(255,0,0),-1,string3,i+1,fig->pontos[i].x,
		             fig->pontos[i].y,fig->pontos[i].z,fig->vertices[i].ponto.x,fig->vertices[i].ponto.y,
					 fig->vertices[i].ponto.z);
#endif
		
	}		
	
}	   
