#include "biblioteca.h" 


inline void ajeitar_cor(COR *c) {
	if(c->x > 255) c->x = 255;	
	if(c->x < 0)   c->x = 0;
	
	if(c->y > 255) c->y = 255;	
	if(c->y < 0)   c->y = 0;
	
	if(c->z > 255) c->z = 255;	
	if(c->z < 0)   c->z = 0;
}


inline COR soma_cor(COR c1, COR c2) {
	COR retorno;
	retorno.x = c1.x + c2.x;
	retorno.y = c1.y + c2.y;
	retorno.z = c1.z + c2.z;
	
	ajeitar_cor(&retorno);
	return retorno;	
}


inline COR multiplica_cor(COR c1, COR c2) {
	COR retorno;
	retorno.x = c1.x * c2.x;
	retorno.y = c1.y * c2.y;
	retorno.z = c1.z * c2.z;
	
	ajeitar_cor(&retorno);
	return retorno;	
}




// Subtrao de 2 pontos p1, p2
inline VETOR criar_vetor(PONTO p1, PONTO p2) {
	VETOR retorno = subtracao( p2 , p1 );
	return retorno;
}


// Soma de 2 vetores v1, v2
inline VETOR soma(VETOR v1, VETOR v2) {
	VETOR retorno; 
	retorno.x = v1.x + v2.x;
	retorno.y = v1.y + v2.y;
	retorno.z = v1.z + v2.z;
	return retorno;
}

// Subtrao de 2 vetores v1, v2
inline VETOR subtracao(VETOR v1, VETOR v2) {
	VETOR retorno; 
	retorno.x = v1.x - v2.x;
	retorno.y = v1.y - v2.y;
	retorno.z = v1.z - v2.z;
	return retorno;
}

// Multiplicao de um vetor por uma constante
inline VETOR multiplicacao(VETOR v1, double k) {
	VETOR retorno; 
	retorno.x = v1.x * k;
	retorno.y = v1.y * k;
	retorno.z = v1.z * k;
	return retorno;
}

// Diviso de um vetor por uma constante
inline VETOR divisao(VETOR v1, double k) {
	VETOR retorno; 
	retorno.x = v1.x / k;
	retorno.y = v1.y / k;
	retorno.z = v1.z / k;
	return retorno;
}

// Produto Interno de 2 VETORes
inline double produtoInterno(VETOR v1, VETOR v2) {
	double retorno = (v1.x * v2.x) + (v1.y * v2.y) + (v1.z * v2.z);
	return retorno;
}

// Produto VETORial de 2 VETORes
inline VETOR produtoVetorial(VETOR v1, VETOR v2) {
	VETOR retorno; 
	retorno.x = (v1.y * v2.z) - (v1.z * v2.y);
	retorno.y = (v1.z * v2.x) - (v1.x * v2.z);
	retorno.z = (v1.x * v2.y) - (v1.y * v2.x);
	return retorno;
}

// Norma de um VETOR
inline double norma(VETOR v1) {
	double retorno = sqrt(produtoInterno(v1, v1));
	return retorno;
}

// Retorno um VETOR unitrio com a mesma direo do VETOR passado como parmetro
inline void normalizar(VETOR *v1) {
    VETOR tmp = divisao(*v1, norma(*v1));
	v1->x = tmp.x;
	v1->y = tmp.y;
	v1->z = tmp.z;
}


// Projecao de um VETOR v1 sobre v2
inline VETOR projecao(VETOR v1, VETOR v2) {
    VETOR retorno;
	retorno = multiplicacao( v2, (produtoInterno(v1,v2) / produtoInterno(v2,v2)) );
	return retorno;
}


// Devolve uma matriz de mudana de Base Ortonormal pra Coordenadas de Vista
// Parmetros:
// - U (coordenada horizontal da Cmera Virtual)
// - V (coordenada vertical da Cmera Virtual)
// - N (mira da Cmera Virtual)
inline MATRIZ getMatriz(VETOR u, VETOR v, VETOR n) {
	MATRIZ retorno;
	retorno.array[0] = u;
	retorno.array[1] = v;
	retorno.array[2] = n;
	return retorno;
}


// Multiplicacao de uma Matriz M 3x3 por um VETOR v1
inline VETOR Multiplicacao(MATRIZ m, VETOR v1) {
	VETOR retorno; 
	retorno.x = produtoInterno( m.array[0] , v1 );
	retorno.y = produtoInterno( m.array[1] , v1 );
	retorno.z = produtoInterno( m.array[2] , v1 );
	return retorno;
}

