#include "biblioteca.h"


///////////////////////////////////////////////////// adicionei :
// CAMERA

// Cria cmera
CAMERA *criar_camera() {
	CAMERA *tmp = (CAMERA *) malloc(sizeof(CAMERA));
	
	tmp->foco.x =  10.0;
	tmp->foco.y =  200.0;
	tmp->foco.z =  200.0;
	
	tmp->mira.x =  0.0;
	tmp->mira.y = -10.0;
	tmp->mira.z = -5.0;
	
	tmp->vertical.x =  0.0;
	tmp->vertical.y = -2.0;
	tmp->vertical.z =  0.0;
	
	tmp->d = 0.1;
	tmp->hx = 0.1;
	tmp->hy = 0.1;
	
	return tmp;
}




OBJETO *criar_objeto() {
	OBJETO *tmp = (OBJETO *) malloc(sizeof(OBJETO));
	
	tmp->n = 10;
	tmp->ks = 1;
	
	tmp->kd.x = 1;
	tmp->kd.y = 1;
	tmp->kd.z = 1;
	
	tmp->cor.x = 0.25;
	tmp->cor.y = 0.75;
	tmp->cor.z = 0.25;

	if(tmp->kd.x < 0  || tmp->kd.x > 1  || tmp->kd.y < 0  || tmp->kd.y > 1  || tmp->kd.z < 0  || 
	   tmp->kd.z > 1  || tmp->cor.x < 0 || tmp->cor.x > 1 || tmp->cor.y < 0 || tmp->cor.y > 1 ||
	   tmp->cor.z < 0 || tmp->cor.z > 1 ||  tmp->ks < 0   ||  tmp->ks > 1   || tmp->n < 0) {
		return NULL;		
	}
	
	return tmp;
}




CENA *criar_cena() {
	CENA *tmp = (CENA *) malloc(sizeof(CENA));
	
	tmp->ka = 0.2;
	
	tmp->fonte_luz.x = -2000;
	tmp->fonte_luz.y = 2000;
	tmp->fonte_luz.z = 200;
	
	tmp->cor_luz.x = 255;
	tmp->cor_luz.y = 255;
	tmp->cor_luz.z = 255;
	
	tmp->cor_ambiente.x = 255;
	tmp->cor_ambiente.y = 255;
	tmp->cor_ambiente.z = 255;
	
	if(tmp->cor_ambiente.x < 0   || tmp->cor_ambiente.x > 255 || tmp->cor_ambiente.y < 0   ||
	   tmp->cor_ambiente.x > 255 || tmp->cor_ambiente.z < 0   || tmp->cor_ambiente.z > 255 ||
	   tmp->cor_luz.x < 0   || tmp->cor_luz.x > 255 || tmp->cor_luz.y < 0 || 
	   tmp->cor_luz.y > 255 || tmp->cor_luz.z < 0   || tmp->cor_luz.z > 255) {
		return NULL;		
	}
	
	return tmp;	
}






void erro(char *string) {
	textprintf_ex(screen,font,10,10,makecol(255,0,0),-1,string);
	system("pause");
}




// Executa 

int executar() {
	BITMAP *buffer;
	CAMERA *cam;
	FIGURA *fig;	
	OBJETO *obj;
	CENA *cena;	
	ZBUFF *zbuff;
	int pos, mouse_posX,mouse_posY;
	char reloadFig = 0, reloadConfig = 0, mudou = 0, pressed = 0;
	char ajeitarLuz = 1;
	
	freopen("debug.txt","w",stdout);
	buffer =  create_bitmap(RES_X, RES_Y);
	zbuff = (ZBUFF *) malloc(sizeof(ZBUFF));
	
	obj = criar_objeto();
	cena = criar_cena();	
	cam = criar_camera();
	if( lerConfig(cam, obj, cena) == 0 ) {
		erro("erro na leitura do arquivo config.txt");		
		return 0;
	}
	
	textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"LENDO ARQUIVO" );
	fig = lerArquivo("coracao.txt");
	if(cam == NULL || cena == NULL || obj == NULL || fig == NULL) { 
		erro("erro na inicializacao");
		return 0;
	}
	
	clear_bitmap(screen);
	textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO." );
	transformar_coordenadas(fig,cam,cena,ajeitarLuz);
	textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO.." );
	normalizar_e_colorir_vertices(fig, cam, obj, cena);			
	textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO..." );
	renderizar(fig,cam,zbuff,buffer);
	textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO...." );
    ajeitarLuz = 0;



#ifdef DEBUG_CAM2
    char *string = "hx %lf , hy %lf, d %lf    c = %lf,%lf,%lf";
	char *string2 = "n = %lf,%lf,%lf ,v = %lf,%lf,%lf ,u = %lf,%lf,%lf";
	
	textprintf_ex(buffer,font,10,5,makecol(100,100,100),-1,string, cam->hx,cam->hy,cam->d,
	              cam->foco.x,cam->foco.y ,cam->foco.z );
	textprintf_ex(buffer,font,10,20,makecol(100,100,100),-1,string2,cam->mira.x,cam->mira.y,
				  cam->mira.z,cam->vertical.x,cam->vertical.y,cam->vertical.z,
		          cam->horizontal.x,cam->horizontal.y,cam->horizontal.z );	     
#endif	 

	rectfill(buffer,100,40,300,60,makecol(26,123,200));
	textprintf_ex(buffer,font,130,47,makecol(10,10,10),-1,"RELOAD  figura.txt" );
				     
	rectfill(buffer,RES_X-300,40,RES_X-100,60,makecol(26,123,200));
	textprintf_ex(buffer,font,RES_X-270,47,makecol(10,10,10),-1,"RELOAD  config.txt" );
			
	blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	
	
	
	
	while (!key[KEY_ESC]) { 
		
		// CHECA O MOUSE
		pos = mouse_pos;// x encontra-se nos 16 bits iniciais e y nos 16 finais
		mouse_posX = pos >> 16; 
		mouse_posY = pos & 0x0000ffff;
		
		if(mouse_b & 1)	{		
			if(!pressed) {
				pressed = 1;
				if(mouse_posX > 100 && mouse_posX < 300 && mouse_posY > 40 && mouse_posY < 60)
					reloadFig = 1;					
				if(mouse_posX > RES_X-300 && mouse_posX < RES_X-100 && mouse_posY > 40 && 
				   mouse_posY < 60)
					reloadConfig = 1;								
			}
		} else if(pressed) {	
			if(reloadFig || reloadConfig) mudou = 1;			
			if(reloadFig) {
				destruirFigura(fig);
				fig = lerArquivo("figura.txt");
				if(fig == NULL) {
					erro("erro na leitura do arquivo figura.txt");
					return 0;
				}
			}  
			if(reloadConfig)  {
				ajeitarLuz = 1;
				if( lerConfig(cam, obj, cena) == 0 ) {
					erro("erro na leitura do arquivo config.txt");		
					return 0;
				}
			}
			pressed = 0;
			reloadFig = 0;
			reloadConfig = 0;							 
		}
			 
		
		
		// CHECA O TECLADO		
		if(keypressed()) {
			mudou = checarTeclas(cam, fig);
	        clear_keybuf();
		}
		
		
		//REDESENHA A FIGURA SE ALGUM PARAMENTRO MUDOU
		if(mudou)  {
			mudou = 0;				
			clear(buffer);	
			
			textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO." );
			transformar_coordenadas(fig,cam,cena,ajeitarLuz);
		    textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO.." );
			normalizar_e_colorir_vertices(fig, cam, obj, cena);			
		    textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO..." );
		    renderizar(fig,cam,zbuff,buffer);
		    textprintf_ex(screen,font,50,RES_Y-50,makecol(250,0,0),-1,"CALCULANDO...." );
    		ajeitarLuz = 0;
    
		#ifdef DEBUG_CAM2
		    char *string = "hx %lf , hy %lf, d %lf    c = %lf,%lf,%lf";
			char *string2 = "n = %lf,%lf,%lf ,v = %lf,%lf,%lf ,u = %lf,%lf,%lf";
			textprintf_ex(buffer,font,10,5,makecol(100,100,100),-1,string, cam->hx,cam->hy,cam->d,
		                  cam->foco.x,cam->foco.y ,cam->foco.z );
	 		textprintf_ex(buffer,font,10,20,makecol(100,100,100),-1,string2,cam->mira.x,cam->mira.y,
			    		  cam->mira.z,cam->vertical.x,cam->vertical.y,cam->vertical.z,
		      	          cam->horizontal.x,cam->horizontal.y,cam->horizontal.z );	     
		#endif
			rectfill(buffer,100,40,300,60,makecol(26,123,200));
			textprintf_ex(buffer,font,130,47,makecol(10,10,10),-1,"RELOAD  figura.txt" );
					     
			rectfill(buffer,RES_X-300,40,RES_X-100,60,makecol(26,123,200));
			textprintf_ex(buffer,font,RES_X-270,47,makecol(10,10,10),-1,"RELOAD  config.txt" );
			
			
			blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
		}			
		
		vsync();
		show_mouse(screen);
		vsync();
	
	}
	
	return 0;
}





void varrer(BITMAP *buffer, FIGURA *fig, int v1, int v2, int v3, ZBUFF *zbuff, double xmin, 
            double xmax, double y, double d){
	double x = xmin;
	double alfa,beta,gama,z;
	double det,det_alfa,det_beta;
	COR cor,cor1,cor2,cor3;
	PONTO *p1,*p2,*p3;
	p1 = &(fig->vertices[v1].ponto);
	p2 = &(fig->vertices[v2].ponto);
	p3 = &(fig->vertices[v3].ponto);
	
	
	for (; x <= xmax; x+=1) {
		det      = ((p1->x - p3->x) * (p2->y - p3->y)) - ((p2->x - p3->x) * (p1->y - p3->y));
		det_alfa = ((    x - p3->x) * (p2->y - p3->y)) - ((p2->x - p3->x) * (    y - p3->y));
		det_beta = ((p1->x - p3->x) * (    y - p3->y)) - ((    x - p3->x) * (p1->y - p3->y));
		alfa = det_alfa / det;
		beta = det_beta / det;
		gama = 1 - alfa - beta;
		
		
		z = (alfa * p1->z) + (beta * p2->z) + (gama * p3->z);
		
		if (x > 0 && x < RES_X && y > 0 && y < RES_Y && z >= d && z < zbuff->matriz[(int)y][(int)x]) {
			zbuff->matriz[ (int)y ] [ (int)x ] = z;
			
			cor1 = multiplicacao(fig->vertices[v1].cor , alfa);
			cor2 = multiplicacao(fig->vertices[v2].cor , beta);
			cor3 = multiplicacao(fig->vertices[v3].cor , gama);
			ajeitar_cor(&cor1);
			ajeitar_cor(&cor2);
			ajeitar_cor(&cor3);
			
			cor = soma_cor(cor1,cor2);
			cor = soma_cor(cor,cor3);
								
			putpixel( buffer, (int)x, (int)y, makecol(cor.x,cor.y,cor.z) );
			printf("Alfa = %lf   Beta = %lf  Gama = %lf     R = %lf  G = %lf  B = %lf\n",alfa,beta,gama,
			       cor.x,cor.y,cor.z);		
		}
	}
	
}
	




int menorzinho(PONTO *a,PONTO *b) {
	if (a->y < b->y) return 1;
	if (a->y > b->y) return 0;
	
	if (a->x <= b->x) return 1;
	if (a->x > b->x)  return 0;

	return 0;
}





void renderizar(FIGURA *fig, CAMERA *cam, ZBUFF *zbuff, BITMAP *buffer) {
	int i,j,tmp;
	int menorint,menorint2,menorint3;
	double xmin,xmax,yscan,ymax,xmeio;
	double coef1,coef2,coefA,coefB,coefC; 
	
	PONTO p1,p2,p3;
	VERTICE *menor,*menor2,*menor3,*temp;
	
	VERTICE *v = fig->vertices;
	TRIANGULO *t = fig->triangulos;	
	
	for (i = 0; i < RES_Y; i++) {
		for (j = 0; j < RES_X; j++) {
			zbuff->matriz[i][j] = 999999;
		}
	}
	
			

	for(i = 0; i < fig->nt; i++) {
		
		// Ordena os vertices
		menor  = &( v[t[i].v1] );
		menor2 = &( v[t[i].v2] );
		menor3 = &( v[t[i].v3] );
		menorint  = t[i].v1;
		menorint2 = t[i].v2;
		menorint3 = t[i].v3;

		tmp = menorzinho( &(menor2->ponto) , &(menor->ponto) );
		if (tmp == 1) {
			temp = menor;
			menor = menor2;
			menor2 = temp;
			menorint ^= menorint2 ^= menorint ^= menorint2;			
		}
		
		tmp = menorzinho( &(menor3->ponto) , &(menor->ponto) );
		if (tmp == 1) {
			temp = menor;
			menor = menor3;
			menor3 = temp;
			menorint ^= menorint3 ^= menorint ^= menorint3;
		}
				
		tmp = menorzinho( &(menor3->ponto) , &(menor2->ponto) );
		if (tmp == 1) {
			temp = menor2;
			menor2 = menor3;
			menor3 = temp;
			menorint2 ^= menorint3 ^= menorint2 ^= menorint3;						
		}		
			  	    
						
		p1 = menor->ponto;
		p2 = menor2->ponto;
		p3 = menor3->ponto;
			
		if (p2.x - p1.x == 0) coefA = -1; 
		else coefA = (p2.y - p1.y) / (p2.x - p1.x);
		
		if (p3.x - p1.x == 0) coefB = -1;
		else coefB = (p3.y - p1.y) / (p3.x - p1.x);
		
		if (p3.x - p2.x == 0) coefC = -1;
		else coefC = (p3.y - p2.y) / (p3.x - p2.x);
		
		
		if (coefB == -1) xmeio = p1.x;		
		else xmeio = ((p2.y - p1.y) / coefB) + p1.x;
						
			
				

		if (p1.y < p2.y) { 
			//if (xmeio == p2.x) textprintf_ex(buffer,font,10,20,makecol(255,0,0),-1,"Estas loco?");
			if (xmeio >= p2.x) {
				coef1 = coefA;
				coef2 = coefB;
			}			
			else { // Quando xmeio < p2->x
				coef1 = coefB;
				coef2 = coefA;
			}
			
			xmin = xmax = p1.x;
			yscan = p1.y;
			ymax = p2.y;
			if(ymax > RES_Y) ymax = RES_Y;
			
			for (;yscan <= ymax; yscan+=0.45) {
				if(yscan >= 0 && yscan < RES_Y) {
					varrer(buffer,fig,menorint,menorint2,menorint3,zbuff,xmin,xmax,yscan,cam->d);
				}
			    if (coef1 != -1) xmin += 0.45 / coef1;
				if (coef2 != -1) xmax += 0.45 / coef2;
			}		
		}
		
			
		
		if (p2.y < p3.y) { 
			//if (xmeio == p2.x) textprintf_ex(buffer,font,10,40,makecol(255,0,0),-1,"Estas loco?"); // Se acontecer,a culpa nao eh de ninguem
			if (xmeio >= p2.x) {
				coef1 = coefC;
				coef2 = coefB;
			}			
			else { // Quando xmeio < p2->x
				coef1 = coefB;
				coef2 = coefC;
			}			
			xmin = xmax = p3.x;
			yscan = p3.y;
			ymax = p2.y;
			if(ymax < 0) ymax = 0;
					
			for(;yscan >= ymax; yscan -=0.45) {											
				if(yscan >= 0 && yscan < RES_Y) {
					varrer(buffer,fig,menorint,menorint2,menorint3,zbuff,xmin,xmax,yscan,cam->d);
			    }
			    if (coef1 != -1) xmin -= 0.45 / coef1;
				if (coef2 != -1) xmax -= 0.45 / coef2;
			}		
		}	
		
	
	
		/*if (!(p2.y < p3.y) && !(p1.y < p2.y)) {			
			textprintf_ex(screen,font,10,50,makecol(255,0,0),-1,"EITA ISSO NUM ERA PRA ACONTECER");
			system("pause");			
		}*/
	}	
	
}
