#include <allegro.h>
#include <stdio.h>
#include <math.h>

#define PI 3.14159265

#define RES_X 800
#define RES_Y 600
//#define RES_X 1000
//#define RES_Y 700


// debug's
//#define DEBUG_READING1
//#define DEBUG_READING2
//#define DEBUG_CAM1
#define DEBUG_CAM2
//#define DEBUG_COORD1
//#define DEBUG_COORD2
//#define DEBUG_NORMAL
//#define DEBUG_COR



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// structs para as operacoes de vetores
 

struct Vetor {
	double x;
	double y;
	double z;
} typedef VETOR,PONTO,COR;



struct Matriz {
	VETOR array[3];
} typedef MATRIZ;


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// structs para as operacoes da figura

struct vertice {
    PONTO ponto;        
    int proximo;
	int nt;  // Numero de triangulos que esse vertice faz parte
	int *tr; // OOOS PIRATA (triangulos)
	
	COR cor;	
}typedef VERTICE;


struct triangulo {
	int v1,v2,v3;
	VETOR normal;
}typedef TRIANGULO;   



struct figura {
    int np,nt;
    PONTO *pontos;
	VERTICE *vertices;
    TRIANGULO *triangulos;    
}typedef FIGURA;



struct camera {
	PONTO foco; // C
	VETOR mira; // N 
	VETOR vertical; // V
	VETOR horizontal; // U
	double hx,hy;
	double d;	   
}typedef CAMERA;

struct RNP {	
	double ka;
	COR cor_ambiente;	
	COR cor_luz;
	PONTO fonte_luz;
} typedef CENA;

struct OBJ {
	VETOR kd;
	COR cor;
	double ks;
	double n;
} typedef OBJETO;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////



struct zbuff {
	double matriz[RES_Y][RES_X];   	   
}typedef ZBUFF;




////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Operacoes com cores
inline void ajeitar_cor(COR *c);
inline COR soma_cor(COR c1, COR c2);
inline COR multiplica_cor(COR c1, COR c2);


// Operacoes vetoriais
inline VETOR criar_vetor(PONTO p1, PONTO p2);

inline VETOR soma(VETOR v1, VETOR v2);
inline VETOR subtracao(VETOR v1, VETOR v2);
inline VETOR multiplicacao(VETOR v1, double k);
inline VETOR divisao(VETOR v1, double k);

inline double produtoInterno(VETOR v1, VETOR v2);
inline VETOR produtoVetorial(VETOR v1, VETOR v2);
inline VETOR projecao(VETOR v1, VETOR v2);

inline double norma(VETOR v1);
inline void normalizar(VETOR *v1);

inline VETOR Multiplicacao(MATRIZ m, VETOR v1);
inline MATRIZ getMatriz(VETOR u, VETOR v, VETOR n);


//////////////////////////////////////////////////////////////////////

// Operacoes com a figura

FIGURA *criarFigura(int p, int t);
void destruirFigura(FIGURA *fig);
FIGURA *lerArquivo(char *nomeArquivo);
char lerConfig(CAMERA *cam, OBJETO *obj, CENA*cena);

void transformar_coordenadas(FIGURA *f,CAMERA *cam, CENA *cena, char ajeitarLuz);
void normalizar_e_colorir_vertices(FIGURA *fig, CAMERA *cam, OBJETO * obj, CENA *cena);

////////////////////////////////////////////////////////////////////////////////

// Controle das teclas
char checarTeclas(CAMERA *cam, FIGURA *fig);

void translacaoHorizontal(CAMERA *cam, int paraEsq);
void translacaoVertical(CAMERA *cam, int paraCima);
void translacaoProfundidade(CAMERA *cam, int paraDentro);

void rotacaoHorizontal(CAMERA *cam, int paraEsq);
void rotacaoVertical(CAMERA *cam, int paraCima);
void rotacaoProfundidade(CAMERA *cam, int paraDentro);


///////////////////////////////////////////////////////////////////////

// Manipulacoes da camera e da tela

CAMERA *criar_camera(); 
OBJETO *criar_objeto(); 
CENA *criar_cena();
int executar();
 
int menorzinho(PONTO *a,PONTO *b);
void renderizar(FIGURA *fig, CAMERA *cam, ZBUFF *zbuff, BITMAP *buffer);
void varrer(BITMAP *buffer, FIGURA *fig, int v1, int v2, int v3, ZBUFF *zbuff, double xmin,
            double xmax, double y, double d);
//void imprimirPixel(ZBUFF *zbuff, FIGURA *fig, int t, int x, int y, double d);






