#include "biblioteca.h"


// Controle das teclas
char checarTeclas(CAMERA *cam, FIGURA *fig) {
	char mudou = 0;
	
	if (key[KEY_W]) {
		mudou = 1;
		translacaoVertical(cam, 1);
	}
	if (key[KEY_S]) {
		mudou = 1;
		translacaoVertical(cam, 0);
	}
	if (key[KEY_A])  {
		mudou = 1;
		translacaoHorizontal(cam, 1);
	}
	if (key[KEY_D])  {
		mudou = 1;
		translacaoHorizontal(cam, 0);
	}	
	if (key[KEY_X])  {
		mudou = 1;
		translacaoProfundidade(cam, 1); 
	}
	if (key[KEY_Z])  {
		mudou = 1;
		translacaoProfundidade(cam, 0);
	}
	
				
	if (key[KEY_U])	 {
		mudou = 1;
		rotacaoVertical(cam,1);
	}
	if (key[KEY_J])  {
		mudou = 1;
		rotacaoVertical(cam,0);
	}
	if (key[KEY_N])	 {
		mudou = 1;
		rotacaoHorizontal(cam,1);
	}
	if (key[KEY_M])	 {
		mudou = 1;
		rotacaoHorizontal(cam,0);
	}
	
	if (key[KEY_H])	 {
		mudou = 1;
		rotacaoProfundidade(cam,1);
	}
	if (key[KEY_K])	 {
		mudou = 1;
		rotacaoProfundidade(cam,0);
	}
	
	// ZOOM IN		
	if (key[KEY_MINUS_PAD]) {
		mudou = 1;
		cam->hx += 0.1;
	    cam->hy += 0.1;
    }
	
	// ZOOM OUT
	if (key[KEY_PLUS_PAD] && cam->hx > 0) {
	    mudou = 1;
		cam->hx -= 0.1;
	    cam->hy -= 0.1;
	    if(cam->hx < 0) {
			cam->hx = 0.0;
	        cam->hy = 0.0;
		}	        
    }	
    
    return mudou;
}


void translacaoHorizontal(CAMERA *cam, int paraEsq) {
	int coef = 50;
	
	if (paraEsq) {
		coef = -50;
    }
    // cam->vertical->x += coef;
    // cam->horizontal->x += coef;
    //cam->mira->x += coef;
    
    cam->foco.x += coef;
}

void translacaoVertical(CAMERA *cam, int paraCima) {
	int coef = 50;
	
    if (paraCima) {
		coef = -50;
    }
	//cam->vertical->y += coef;
    // cam->horizontal->y += coef;
    // cam->mira->y += coef;
   
    cam->foco.y += coef;
}


void translacaoProfundidade(CAMERA *cam, int paraDentro) {
	int coef = 50;
	
    if (paraDentro) {
		coef = -50;
    }
    //cam->vertical->y += coef;
    // cam->horizontal->y += coef;
    // cam->mira->y += coef;
    
    cam->foco.z += coef;
}



void rotacaoHorizontal(CAMERA *cam, int paraEsq) {
	double angulo = 20;
    double seno = sin(angulo*PI/180);
    double cosseno = cos(angulo*PI/180);
    double vx, vy, vz, ux, uy, uz, nx, ny, nz, focox, focoy, focoz ;
	
	vx = cam->vertical.x;
    vy = cam->vertical.y;
    vz = cam->vertical.z;
       
    ux = cam->horizontal.x;
    uy = cam->horizontal.y;
    uz = cam->horizontal.z;
       
    nx = cam->mira.x;
    ny = cam->mira.y;
    nz = cam->mira.z;
       
    focox = cam->foco.x;
    focoy = cam->foco.y;
    focoz = cam->foco.z;
	
    if (paraEsq) {
		seno = sin(-(angulo*PI/180));
        cosseno = cos(-(angulo*PI/180));
    }
    
    // Ry
    cam->vertical.x = cosseno*vx + seno*vz;
    // y se mantem
    cam->vertical.z = -seno*vx + cosseno*vz;
    
    
    cam->horizontal.x = cosseno*ux + seno*uz;
    // y se mantem
    cam->horizontal.z = -seno*ux + cosseno*uz;
    
    
    cam->mira.x = cosseno*nx + seno*nz;
    // y se mantem
    cam->mira.z = -seno*nx + cosseno*nz;
    
    
    cam->foco.x = cosseno*focox + seno*focoz;
    // y se mantem
    cam->foco.z = -seno*focox + cosseno*focoz;

    
    
}

void rotacaoVertical(CAMERA *cam, int paraCima) {
	double angulo = 20;
    double seno = sin(angulo*PI/180);
    double cosseno = cos(angulo*PI/180);
    double vx, vy, vz, ux, uy, uz, nx, ny, nz, focox, focoy, focoz ;
	
	vx = cam->vertical.x;
    vy = cam->vertical.y;
    vz = cam->vertical.z;
       
    ux = cam->horizontal.x;
    uy = cam->horizontal.y;
    uz = cam->horizontal.z;
       
    nx = cam->mira.x;
    ny = cam->mira.y;
    nz = cam->mira.z;
       
    focox = cam->foco.x;
    focoy = cam->foco.y;
    focoz = cam->foco.z;
	
    if (paraCima) {
		seno = sin(-(angulo*PI/180));
        cosseno = cos(-(angulo*PI/180));
    }
    
    // Rx
    cam->vertical.y = cosseno*vy - seno*vz;
    // y se mantem
    cam->vertical.z = seno*vy + cosseno*vz;
    
    
    cam->horizontal.y = cosseno*uy - seno*uz;
    // y se mantem
    cam->horizontal.z = seno*uy + cosseno*uz;
    
    
    cam->mira.y = cosseno*ny - seno*nz;
    // y se mantem
    cam->mira.z = seno*ny + cosseno*nz;
    
    
    cam->foco.y = cosseno*focoy - seno*focoz;
    // y se mantem
    cam->foco.z = seno*focoy + cosseno*focoz;    
}
     

void rotacaoProfundidade(CAMERA *cam, int paraDentro) {
    double angulo = 20;
    double seno = sin(angulo*PI/180);
    double cosseno = cos(angulo*PI/180);
    double vx, vy, vz, ux, uy, uz, nx, ny, nz, focox, focoy, focoz ;
	
	vx = cam->vertical.x;
    vy = cam->vertical.y;
    vz = cam->vertical.z;
       
    ux = cam->horizontal.x;
    uy = cam->horizontal.y;
    uz = cam->horizontal.z;
       
    nx = cam->mira.x;
    ny = cam->mira.y;
    nz = cam->mira.z;
       
    focox = cam->foco.x;
    focoy = cam->foco.y;
    focoz = cam->foco.z;
	
    if (paraDentro) {
		seno = sin(-(angulo*PI/180));
        cosseno = cos(-(angulo*PI/180));
    }
    
    // Rz
    cam->vertical.x = cosseno*vx - seno*vy;
    // z se mantem
    cam->vertical.y = seno*vx + cosseno*vy;
    
    
    cam->horizontal.x = cosseno*ux - seno*uy;
    // z se mantem
    cam->horizontal.y = seno*ux + cosseno*uy;
    
    
    cam->mira.x = cosseno*nx - seno*ny;
    // z se mantem
    cam->mira.y = seno*nx + cosseno*ny;
    
    
    cam->foco.x = cosseno*focox - seno*focoy;
    // z se mantem
    cam->foco.y = seno*focox + cosseno*focoy;   
}
